/*  Creation */
void q_zero (double q1[]);
void q_one (double q1[]);
void q_construct (double q1[], double t, double x, double y, double z);
void get_q1   (int args, char *argv[], double q1[]);
void get_q1_d (int args, char *argv[], double q1[], double *d);
void get_q1_i (int args, char *argv[], double q1[], int *i);
void get_q1_q2   (int args, char *argv[], double q1[], double q2[]);
void get_q1_q2_i (int args, char *argv[], double q1[], double q2[], int *i);

void q_random_01 (double q1[]);
void q_random_011 (double q1[]);
void q_random_11 (double q1[]);

void q_copy (double q1[], double q_out[]);
void q_dup (double q1[], double q_out[]);

/*  Unary operators: parts */
void q_scalar (double q1[], double q_out[]);
void q_vector (double q1[], double q_out[]);

/*  Unary operators: sizes */
void q_abs (double q1[], double q_out[]);
void d_abs (double q1[], double *d);
void q_abs_vector (double q1[], double q_out[]);
void d_abs_vector (double q1[], double *d);
void q_norm (double q1[], double q_out[]);
void d_norm (double q1[], double *d);
void q_norm_vector (double q1[], double q_out[]);
void d_norm_vector (double q1[], double *d);
void q_det (double q1[], double q_out[]);
void d_det (double q1[], double *d);
void q_tau_squared (double q1[], double q_out[]);
void d_tau_squared (double q1[], double *d_out);

/*  Unary operators: automorphisms */
void q_identity (double q1[], double q_out[]);
void q_conj (double q1[], double q_out[]);
void q_conj_1 (double q1[], double q_out[]);
void q_conj_2 (double q1[], double q_out[]);
void q_inv (double q1[], double q_out[]);
void q_adj (double q1[], double q_out[]);

/*  Unary operators: trig */
void q_sin (double q1[], double q_out[]);
void q_cos (double q1[], double q_out[]);
void q_tan (double q1[], double q_out[]);

void q_asin (double q1[], double q_out[]);
void q_acos (double q1[], double q_out[]);
void q_atan (double q1[], double q_out[]);

void q_sinh (double q1[], double q_out[]);
void q_cosh (double q1[], double q_out[]);
void q_tanh (double q1[], double q_out[]);

void q_asinh (double q1[], double q_out[]);
void q_acosh (double q1[], double q_out[]);
void q_atanh (double q1[], double q_out[]);


/*  Unary operators: exponentials */
void q_exp (double q1[], double q_out[]);
void q_ln (double q1[], double q_out[]);
void q_to_n (double q1[], double d, double q_out[]);

/*  Binary operators: +/- */
void q_add_scalar (double q1[], double d, double q_out[]);
void q_add (double q1[], double q2[], double q_out[]);
void q_sub (double q1[], double q2[], double q_out[]);

/*  Binary operators: multiplication/division */
void q_x_scalar (double q1[], double d, double q_out[]);
void q_x (double q1[], double q2[], double q_out[]);
void q_x_even (double q1[], double q2[], double q_out[]);
void q_x_odd (double q1[], double q2[], double q_out[]);
void q_x_inv (double q1[], double q2[], double q_out[]);

void q_scan (double q1[]);
void q_print (double q1[]);
